diff --git a/dlls/user32/tests/input.c b/dlls/user32/tests/input.c
index d45edf1..b0f495a 100644
--- a/dlls/user32/tests/input.c
+++ b/dlls/user32/tests/input.c
@@ -1598,6 +1618,1169 @@ static void test_keyboard_layout_name(void)
     ok(!strcmp(klid, "00000409"), "expected 00000409, got %s\n", klid);
 }
 
+static void test_def_raw_input_proc(void)
+{
+    RAWINPUT *input = NULL, raw;
+    LRESULT ret;
+
+    if (!pDefRawInputProc)
+    {
+        win_skip("DefRawInputProc is not available\n");
+        return;
+    }
+
+    ret = pDefRawInputProc(&input, 0, 0);
+    ok(ret == (LRESULT)-1, "DefRawInputProc returned wrong value: expected (LRESULT)-1, got %lu\n", ret);
+
+    ret = pDefRawInputProc(&input, 0, sizeof(RAWINPUTHEADER));
+    ok(ret == S_OK, "DefRawInputProc returned wrong value: expected S_OK, got %lu\n", ret);
+
+    /* Test that DefRawInputProc is ignorant of the other parameters */
+    memset(&raw, 0xFF, sizeof(raw));
+    input = &raw;
+
+    ret = pDefRawInputProc(&input, 1000000, sizeof(RAWINPUTHEADER));
+    ok(ret == S_OK, "DefRawInputProc returned wrong value: expected S_OK, got %lu\n", ret);
+
+    ret = pDefRawInputProc(&input, -1000000, sizeof(RAWINPUTHEADER));
+    ok(ret == S_OK, "DefRawInputProc returned wrong value: expected S_OK, got %lu\n", ret);
+}
+
+static void test_get_raw_input_device_list(void)
+{
+    RAWINPUTDEVICELIST *device_list;
+    UINT ret, count, count2;
+    DWORD error;
+
+    if (!pGetRawInputDeviceList)
+    {
+        win_skip("GetRawInputDeviceList is not available\n");
+        return;
+    }
+
+    count = 0;
+    ret = pGetRawInputDeviceList(NULL, &count, sizeof(RAWINPUTDEVICELIST));
+    ok(ret == 0, "GetRawInputDeviceList returned wrong value: "
+        "expected 0, got %u\n", ret);
+    ok(count >= 1, "GetRawInputDeviceList returned incorrect number of "
+        "raw input device available: expected x >= 1, got %u\n", count);
+
+    device_list = HeapAlloc(GetProcessHeap(), 0, count * sizeof(RAWINPUTDEVICELIST));
+    memset(device_list, 0xFF, count * sizeof(RAWINPUTDEVICELIST));
+
+    SetLastError(0xdeadbeef);
+    count2 = 0;
+    ret = pGetRawInputDeviceList(device_list, &count2, sizeof(RAWINPUTDEVICELIST));
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputDeviceList returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INSUFFICIENT_BUFFER, "GetRawInputDeviceList returned "
+        "wrong error code: %u\n", error);
+    ok(count2 == count, "GetRawInputDeviceList returned incorrect number of devices: "
+        "expected %u, got %u\n", count, count2);
+
+    count2 = count;
+    ret = pGetRawInputDeviceList(device_list, &count2, sizeof(RAWINPUTDEVICELIST));
+    ok(ret == count, "GetRawInputDeviceList returned wrong value: "
+        "expected %u, got %u\n", count, ret);
+    ok(count2 == count, "GetRawInputDeviceList returned incorrect number of devices: "
+        "expected %u, got %u\n", count, count2);
+
+    ok(device_list[0].hDevice != NULL, "First raw input device doesn't have "
+        "a non-null handle\n");
+    ok(device_list[0].dwType == RIM_TYPEMOUSE || device_list[0].dwType == RIM_TYPEKEYBOARD,
+        "First raw input device wasn't a mouse or a keyboard");
+
+    HeapFree(GetProcessHeap(), 0, device_list);
+}
+
+static void test_get_raw_input_device_info_w(void)
+{
+    UINT ret, size = 0, count;
+    RAWINPUTDEVICELIST *devices;
+    WCHAR buffer[512];
+    RID_DEVICE_INFO info;
+    DWORD error;
+
+    if (!pGetRawInputDeviceInfoW || !pGetRawInputDeviceList)
+    {
+        win_skip("GetRawInputDeviceInfoW and GetRawInputDeviceList are not available\n");
+        return;
+    }
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputDeviceInfoW(NULL, 0, NULL, NULL);
+    error = GetLastError();
+    ok(ret == (UINT)-1,  "GetRawInputDeviceInfoW returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_NOACCESS, "GetRawInputDeviceInfoW returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    size = 0;
+    ret = pGetRawInputDeviceInfoW(NULL, 0, NULL, &size);
+    error = GetLastError();
+    ok(ret == (UINT)-1,
+        "GetRawInputDeviceInfoW returned wrong value: expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_HANDLE,
+        "GetRawInputDeviceInfoW returned wrong error code: %u\n", error);
+
+    ret = pGetRawInputDeviceList(NULL, &count, sizeof(RAWINPUTDEVICELIST));
+    ok(ret == 0, "GetRawInputDeviceList failed to return raw input device count\n");
+    ok(count > 0, "Should have at least one raw input device available\n");
+
+    devices = HeapAlloc(GetProcessHeap(), 0, count * sizeof(RAWINPUTDEVICELIST));
+    ok(devices != NULL, "Failed to allocate memory for raw input devices\n");
+    if (!devices)
+        return;
+
+    ret = pGetRawInputDeviceList(devices, &count, sizeof(RAWINPUTDEVICELIST));
+    ok(ret == count, "GetRawInputDeviceList returned incorrect "
+        "number of devices: expected %u, got %u", count, ret);
+
+    SetLastError(0xdeadbeef);
+    size = 0;
+    ret = pGetRawInputDeviceInfoW(devices[0].hDevice, 0, NULL, &size);
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputDeviceInfoW returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRawInputDeviceInfoW returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    size = 0;
+    ret = pGetRawInputDeviceInfoW(devices[0].hDevice, RIDI_DEVICENAME, buffer, &size);
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputDeviceInfoW returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INSUFFICIENT_BUFFER, "GetRawInputDeviceInfoW returned "
+        "wrong error code: %u\n", error);
+
+    size = 0;
+    ret = pGetRawInputDeviceInfoW(devices[0].hDevice, RIDI_DEVICENAME, NULL, &size);
+    ok(ret == 0, "GetRawInputDeviceInfoW returned wrong value: expected 0, got %u\n", ret);
+    ok(size > 5, "GetRawInputDeviceInfoW returned wrong "
+        "device name size: expected x > 5, got %u\n", size);
+
+    buffer[0] = 0;
+    ret = pGetRawInputDeviceInfoW(devices[0].hDevice, RIDI_DEVICENAME, buffer, &size);
+    ok(ret != (UINT)-1 && ret > 0, "GetRawInputDeviceInfoW returned wrong value: "
+        "expected 0 < x < (UINT)-1, got %u\n", ret);
+    size = lstrlenW(buffer);
+    ok(size > 5, "GetRawInputDeviceInfoW returned too short device name: "
+        "expected x > 5, got %u\n", size);
+
+    size = 0;
+    ret = pGetRawInputDeviceInfoW(devices[0].hDevice, RIDI_DEVICEINFO, NULL, &size);
+    ok(ret == 0, "GetRawInputDeviceInfoW returned wrong value: expected 0, got %u\n", ret);
+    ok(size == sizeof(RID_DEVICE_INFO), "GetRawInputDeviceInfoW returned "
+        "wrong device info size: expected sizeof(RID_DEVICE_INFO), got %u\n", size);
+
+    size = sizeof(RID_DEVICE_INFO);
+    info.cbSize = sizeof(RID_DEVICE_INFO);
+    ret = pGetRawInputDeviceInfoW(devices[0].hDevice, RIDI_DEVICEINFO, &info, &size);
+    ok(ret == sizeof(RID_DEVICE_INFO), "GetRawInputDeviceInfoW returned wrong value: "
+        "expected sizeof(RID_DEVICE_INFO), got %u\n", ret);
+
+    size = 0xdeadbeef;
+    ret = pGetRawInputDeviceInfoW(devices[0].hDevice, RIDI_PREPARSEDDATA, NULL, &size);
+    ok(ret == 0, "GetRawInputDeviceInfoW returned wrong value: "
+        "expected 0, got %u\n", ret);
+    ok(size == 0, "GetRawInputDeviceInfoW returned wrong preparsed data size: "
+        "expected 0, got %u\n", size);
+
+    HeapFree(GetProcessHeap(), 0, devices);
+}
+
+static void test_get_raw_input_device_info_a(void)
+{
+    UINT ret, size = 0, count;
+    RAWINPUTDEVICELIST *devices;
+    char buffer[512];
+    RID_DEVICE_INFO info;
+    DWORD error;
+
+    if (!pGetRawInputDeviceInfoA || !pGetRawInputDeviceList)
+    {
+        win_skip("GetRawInputDeviceInfoA and GetRawInputDeviceList are not available\n");
+        return;
+    }
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputDeviceInfoA(NULL, 0, NULL, NULL);
+    error = GetLastError();
+    ok(ret == (UINT)-1,  "GetRawInputDeviceInfoA returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_NOACCESS, "GetRawInputDeviceInfoA returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    size = 0;
+    ret = pGetRawInputDeviceInfoA(NULL, 0, NULL, &size);
+    error = GetLastError();
+    ok(ret == (UINT)-1,
+        "GetRawInputDeviceInfoA returned wrong value: expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_HANDLE,
+        "GetRawInputDeviceInfoA returned wrong error code: %u\n", error);
+
+    ret = pGetRawInputDeviceList(NULL, &count, sizeof(RAWINPUTDEVICELIST));
+    ok(ret == 0, "GetRawInputDeviceList failed to return raw input device count\n");
+    ok(count > 0, "Should have at least one raw input device available\n");
+
+    devices = HeapAlloc(GetProcessHeap(), 0, count * sizeof(RAWINPUTDEVICELIST));
+    ok(devices != NULL, "Failed to allocate memory for raw input devices\n");
+    if (!devices)
+        return;
+
+    ret = pGetRawInputDeviceList(devices, &count, sizeof(RAWINPUTDEVICELIST));
+    ok(ret == count, "GetRawInputDeviceList returned incorrect "
+        "number of devices: expected %u, got %u", count, ret);
+
+    SetLastError(0xdeadbeef);
+    size = 0;
+    ret = pGetRawInputDeviceInfoA(devices[0].hDevice, 0, NULL, &size);
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputDeviceInfoA returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRawInputDeviceInfoA returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    size = 0;
+    ret = pGetRawInputDeviceInfoA(devices[0].hDevice, RIDI_DEVICENAME, buffer, &size);
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputDeviceInfoA returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INSUFFICIENT_BUFFER, "GetRawInputDeviceInfoA returned "
+        "wrong error code: %u\n", error);
+
+    size = 0;
+    ret = pGetRawInputDeviceInfoA(devices[0].hDevice, RIDI_DEVICENAME, NULL, &size);
+    ok(ret == 0, "GetRawInputDeviceInfoA returned wrong value: expected 0, got %u\n", ret);
+    ok(size > 5, "GetRawInputDeviceInfoA returned wrong "
+        "device name size: expected x > 5, got %u\n", size);
+
+    buffer[0] = 0;
+    ret = pGetRawInputDeviceInfoA(devices[0].hDevice, RIDI_DEVICENAME, buffer, &size);
+    ok(ret != (UINT)-1 && ret > 0, "GetRawInputDeviceInfoA returned wrong value: "
+        "expected 0 < x < (UINT)-1, got %u\n", ret);
+    size = strlen(buffer);
+    ok(size > 5, "GetRawInputDeviceInfoA returned too short device name: "
+        "expected x > 5, got %u\n", size);
+
+    size = 0;
+    ret = pGetRawInputDeviceInfoA(devices[0].hDevice, RIDI_DEVICEINFO, NULL, &size);
+    ok(ret == 0, "GetRawInputDeviceInfoA returned wrong value: expected 0, got %u\n", ret);
+    ok(size == sizeof(RID_DEVICE_INFO), "GetRawInputDeviceInfoA returned "
+        "wrong device info size: expected sizeof(RID_DEVICE_INFO), got %u\n", size);
+
+    size = sizeof(RID_DEVICE_INFO);
+    info.cbSize = sizeof(RID_DEVICE_INFO);
+    ret = pGetRawInputDeviceInfoA(devices[0].hDevice, RIDI_DEVICEINFO, &info, &size);
+    ok(ret == sizeof(RID_DEVICE_INFO), "GetRawInputDeviceInfoA returned wrong value: "
+        "expected sizeof(RID_DEVICE_INFO), got %u\n", ret);
+
+    size = 0xdeadbeef;
+    ret = pGetRawInputDeviceInfoA(devices[0].hDevice, RIDI_PREPARSEDDATA, NULL, &size);
+    ok(ret == 0, "GetRawInputDeviceInfoA returned wrong value: "
+        "expected 0, got %u\n", ret);
+    ok(size == 0, "GetRawInputDeviceInfoA returned wrong preparsed data size: "
+        "expected 0, got %u\n", size);
+
+    HeapFree(GetProcessHeap(), 0, devices);
+}
+
+static void test_basic_get_registered_raw_input_devices(void)
+{
+    RAWINPUTDEVICE device, devices[2];
+    BOOL ret;
+    UINT ret2, count;
+    DWORD error;
+
+    if (!pGetRegisteredRawInputDevices || !pRegisterRawInputDevices)
+    {
+        win_skip("GetRegisteredRawInputDevices and RegisterRawInputDevices are not available\n");
+        return;
+    }
+
+    /* Basic tests for GetRegisteredRawInputDevices */
+    SetLastError(0xdeadbeef);
+    ret2 = pGetRegisteredRawInputDevices(NULL, NULL, 0);
+    error = GetLastError();
+    ok(ret2 == (UINT)-1, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret2);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRegisteredRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret2 = pGetRegisteredRawInputDevices(NULL, NULL, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(ret2 == (UINT)-1, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret2);
+    ok(error == ERROR_NOACCESS, "GetRegisteredRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, 1);
+    error = GetLastError();
+    ok(ret2 == (UINT)-1, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret2);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRegisteredRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+
+    device.usUsagePage = HID_USAGE_PAGE_GENERIC;
+    device.usUsage     = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags     = 0;
+    device.hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to subscribe to mouse raw input\n");
+
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 1, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 1, got %u\n", count);
+
+    memset(&devices[0], 0xFF, sizeof(RAWINPUTDEVICE));
+    ret2 = pGetRegisteredRawInputDevices(&devices[0], &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 1, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 1, got %u\n", ret2);
+    ok(memcmp(&device, &devices[0], sizeof(RAWINPUTDEVICE)) == 0,
+        "GetRegisteredRawInputDevices returned incorrect raw input device registration\n");
+
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to resubscribe to mouse raw input\n");
+
+    /* Verify that there is still the only one registration */
+    memset(&devices[0], 0xFF, sizeof(RAWINPUTDEVICE));
+    ret2 = pGetRegisteredRawInputDevices(&devices[0], &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 1, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 1, got %u\n", ret2);
+    ok(memcmp(&device, &devices[0], sizeof(RAWINPUTDEVICE)) == 0,
+        "GetRegisteredRawInputDevices returned incorrect raw input device registration\n");
+
+    device.dwFlags = RIDEV_REMOVE;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe from mouse raw input\n");
+
+    /* Verify that no registrations are present */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+}
+
+static void test_basic_register_raw_input_devices(void)
+{
+    RAWINPUTDEVICE device;
+    BOOL ret;
+    UINT ret2, count;
+    DWORD error;
+
+    if (!pGetRegisteredRawInputDevices || !pRegisterRawInputDevices)
+    {
+        win_skip("GetRegisteredRawInputDevices and RegisterRawInputDevices are not available\n");
+        return;
+    }
+
+    /* Basic tests for RegisterRawInputDevices */
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(NULL, 0, 0);
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(NULL, 0, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    device.usUsagePage = 0;
+    device.usUsage     = 0;
+    device.dwFlags     = 0;
+    device.hwndTarget  = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 0, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    device.usUsagePage = HID_USAGE_PAGE_GENERIC;
+    device.usUsage     = HID_USAGE_GENERIC_MOUSE;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to subscribe to mouse raw input\n");
+
+    device.dwFlags = RIDEV_REMOVE;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe from mouse raw input\n");
+
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to reunsubscribe from mouse raw input\n");
+
+    device.usUsagePage = 0xFF;
+    device.usUsage     = 0xFF;
+    device.dwFlags     = 0;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to subscribe to a non-existing device\n");
+
+    device.dwFlags = RIDEV_REMOVE;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe from a non-existing device\n");
+
+    /* Assert that no registrations are present */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+}
+
+static void test_raw_input_device_flag_preconditions(void)
+{
+    RAWINPUTDEVICE device;
+    BOOL ret;
+    UINT ret2, count;
+    DWORD error;
+
+    if (!pGetRegisteredRawInputDevices || !pRegisterRawInputDevices)
+    {
+        win_skip("GetRegisteredRawInputDevices and RegisterRawInputDevices are not available\n");
+        return;
+    }
+
+    /* Test that RIDEV_REMOVE flags requires hwndTarget to be null*/
+    device.usUsagePage = HID_USAGE_PAGE_GENERIC;
+    device.usUsage     = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags     = RIDEV_REMOVE;
+    device.hwndTarget  = (HWND)-1;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test that RIDEV_PAGEONLY requires usUsage to be 0 */
+    device.usUsage    = 0xFF;
+    device.dwFlags    = RIDEV_PAGEONLY;
+    device.hwndTarget = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test that RIDEV_EXCLUDE requires usUsage to be non-0 */
+    device.usUsage    = 0;
+    device.dwFlags    = RIDEV_EXCLUDE;
+    device.hwndTarget = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test that RIDEV_NOLEGACY cannot be used with other device then mouse and keyboard */
+    device.usUsage    = 0xFF;
+    device.dwFlags    = RIDEV_NOLEGACY;
+    device.hwndTarget = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test that RIDEV_INPUTSINK requires hwndTarget to be non-null */
+    device.usUsage    = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags    = RIDEV_INPUTSINK;
+    device.hwndTarget = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_PARAMETER, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test that RIDEV_CAPTUREMOUSE must be combined with RIDEV_NOLEGACY
+       Since RIDEV_CAPTUREMOUSE == RIDEV_NOHOTKEYS, scope it for the mouse device */
+    device.usUsage    = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags    = RIDEV_CAPTUREMOUSE;
+    device.hwndTarget = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_FLAGS, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test that RIDEV_APPKEYS must be combined with RIDEV_NOLEGACY */
+    device.usUsage    = HID_USAGE_GENERIC_KEYBOARD;
+    device.dwFlags    = RIDEV_APPKEYS;
+    device.hwndTarget = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_FLAGS, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test that RIDEV_APPKEYS cannot be used with mouse */
+    device.usUsage    = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags    = RIDEV_NOLEGACY | RIDEV_APPKEYS;
+    device.hwndTarget = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_FLAGS, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test that RIDEV_NOHOTKEYS cannot be used with mouse */
+    device.usUsage    = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags    = RIDEV_NOHOTKEYS;
+    device.hwndTarget = NULL;
+    SetLastError(0xdeadbeef);
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_FLAGS, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Test reaction to an invalid flag */
+    SetLastError(0xdeadbeef);
+    device.usUsagePage = HID_USAGE_PAGE_GENERIC;
+    device.usUsage     = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags     = 0x80000000;
+    device.hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    error = GetLastError();
+    ok(!ret, "RegisterRawInputDevices should have failed\n");
+    ok(error == ERROR_INVALID_FLAGS, "RegisterRawInputDevices returned "
+        "wrong error code: %u\n", error);
+
+    /* Assert that no registrations are present */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+}
+
+static void test_extended_register_raw_input_devices(void)
+{
+    RAWINPUTDEVICE device, devices[2];
+    BOOL ret;
+    UINT ret2, count;
+
+    if (!pGetRegisteredRawInputDevices || !pRegisterRawInputDevices)
+    {
+        win_skip("GetRegisteredRawInputDevices and RegisterRawInputDevices are not available\n");
+        return;
+    }
+
+    /* Subscribe and unsubscribe from all devices in usage page */
+    device.usUsagePage = HID_USAGE_PAGE_GENERIC;
+    device.usUsage     = 0;
+    device.dwFlags     = RIDEV_PAGEONLY;
+    device.hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to subscribe to a usage page\n");
+
+    device.dwFlags = RIDEV_REMOVE | RIDEV_PAGEONLY;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe to a usage page\n");
+
+    /* Assert that there are no devices registered */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+
+    /* Should allow to exclude a device */
+    device.usUsagePage = HID_USAGE_PAGE_GENERIC;
+    device.usUsage     = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags     = RIDEV_EXCLUDE;
+    device.hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to exclude mouse raw input\n");
+    ok(ret, "Given (&device{1,2,RIDEV_EXCLUDE,0}, 1, sizeof), "
+        "RegisterRawInputDevices should successfully exclude a device from input feed\n");
+
+    /* Assert that there is one registration */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 1, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 1, got %u\n", count);
+
+    device.dwFlags = RIDEV_REMOVE;
+    ret = pRegisterRawInputDevices(&device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe\n");
+
+    /* Should override a device exclusion with an inclusion */
+    devices[0].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[0].usUsage     = HID_USAGE_GENERIC_MOUSE;
+    devices[0].dwFlags     = RIDEV_EXCLUDE;
+    devices[0].hwndTarget  = NULL;
+    devices[1].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[1].usUsage     = HID_USAGE_GENERIC_MOUSE;
+    devices[1].dwFlags     = 0;
+    devices[1].hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(devices, 2, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to exclude and include mouse raw input "
+        "in the same call\n");
+
+    devices[1].dwFlags = RIDEV_REMOVE;
+    ret = pRegisterRawInputDevices(&devices[1], 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe\n");
+
+    /* Assert that there are no devices registered */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+
+    /* Should register a usage page and a device from that usage page,
+       unsubscribing from them separately */
+    devices[0].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[0].usUsage     = 0;
+    devices[0].dwFlags     = RIDEV_PAGEONLY;
+    devices[0].hwndTarget  = NULL;
+    devices[1].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[1].usUsage     = HID_USAGE_GENERIC_MOUSE;
+    devices[1].dwFlags     = 0;
+    devices[1].hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(devices, 2, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to subscribe\n");
+
+    devices[0].dwFlags = RIDEV_REMOVE | RIDEV_PAGEONLY;
+    ret = pRegisterRawInputDevices(&devices[0], 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe\n");
+
+    /* Assert that one device is registered */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 1, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 1, got %u\n", count);
+
+    devices[1].dwFlags = RIDEV_REMOVE;
+    ret = pRegisterRawInputDevices(&devices[1], 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe\n");
+
+    /* Assert that there are no devices registered */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+
+    /* Should include a usage page and exclude a device */
+    devices[0].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[0].usUsage     = 0;
+    devices[0].dwFlags     = RIDEV_PAGEONLY;
+    devices[0].hwndTarget  = NULL;
+    devices[1].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[1].usUsage     = HID_USAGE_GENERIC_MOUSE;
+    devices[1].dwFlags     = RIDEV_EXCLUDE;
+    devices[1].hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(devices, 2, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to subscribe\n");
+
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 2, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 2, got %u\n", count);
+
+    devices[0].dwFlags = RIDEV_REMOVE | RIDEV_PAGEONLY;
+    devices[1].dwFlags = RIDEV_REMOVE;
+    ret = pRegisterRawInputDevices(devices, 2, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe\n");
+
+    /* Assert that there are no devices registered */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+
+    /* Should allow to subscribe and unsubscribe in the same call */
+    devices[0].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[0].usUsage     = HID_USAGE_GENERIC_MOUSE;
+    devices[0].dwFlags     = 0;
+    devices[0].hwndTarget  = NULL;
+    devices[1].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[1].usUsage     = HID_USAGE_GENERIC_MOUSE;
+    devices[1].dwFlags     = RIDEV_REMOVE;
+    devices[1].hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(devices, 2, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to subscribe and unsubscribe in the same call\n");
+
+    /* Assert that there are no devices registered */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+
+    /* Test that RegisterRawInputDevices is atomic,
+       if one device fails to register, no changes are made */
+    devices[0].usUsagePage = HID_USAGE_PAGE_GENERIC;
+    devices[0].usUsage     = HID_USAGE_GENERIC_MOUSE;
+    devices[0].dwFlags     = 0;
+    devices[0].hwndTarget  = NULL;
+    devices[1].usUsagePage = 0;
+    devices[1].usUsage     = 0;
+    devices[1].dwFlags     = 0;
+    devices[1].hwndTarget  = NULL;
+    ret = pRegisterRawInputDevices(devices, 2, sizeof(RAWINPUTDEVICE));
+    ok(!ret, "RegisterRawInputDevices should fail to register the devices\n");
+
+    /* Assert that there are no devices registered */
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+}
+
+static void test_get_raw_input_data(void)
+{
+    UINT ret, count;
+    DWORD error;
+
+    if (!pGetRawInputData)
+    {
+        win_skip("GetRawInputData is not available\n");
+        return;
+    }
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputData(NULL, 0, NULL, NULL, 0);
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputData returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRawInputData returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputData(NULL, 0, NULL, NULL, sizeof(RAWINPUTHEADER));
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputData returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_HANDLE, "GetRawInputData returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputData(NULL, 0, NULL, &count, 1);
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputData returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRawInputData returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputData(NULL, 0, NULL, &count, sizeof(RAWINPUTHEADER));
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputData returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_HANDLE, "GetRawInputData returned "
+        "wrong error code: %u\n", error);
+}
+
+static void test_get_raw_input_buffer(void)
+{
+    UINT ret, size;
+    DWORD error;
+
+    if (!pGetRawInputBuffer)
+    {
+        win_skip("GetRawInputBuffer is not available\n");
+        return;
+    }
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputBuffer(NULL, NULL, 0);
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputBuffer returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRawInputBuffer returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputBuffer(NULL, NULL, sizeof(RAWINPUTHEADER));
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputBuffer returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRawInputBuffer returned "
+        "wrong error code: %u\n", error);
+
+    SetLastError(0xdeadbeef);
+    ret = pGetRawInputBuffer(NULL, &size, 1);
+    error = GetLastError();
+    ok(ret == (UINT)-1, "GetRawInputBuffer returned wrong value: "
+        "expected (UINT)-1, got %u\n", ret);
+    ok(error == ERROR_INVALID_PARAMETER, "GetRawInputBuffer returned "
+        "wrong error code: %u\n", error);
+
+    size = 0xdeadbeef;
+    ret = pGetRawInputBuffer(NULL, &size, sizeof(RAWINPUTHEADER));
+    ok(ret == 0, "GetRawInputBuffer returned wrong value: expected 0, got %u\n", ret);
+    ok(size == 0, "GetRawInputBuffer returned wrong minimal buffer size: "
+        "expected 0, got %u\n", size);
+}
+
+static BOOL wm_input_recieved;
+static BOOL legacy_mouse_message_recieved;
+static BOOL legacy_keyboard_message_recieved;
+
+static LRESULT CALLBACK get_raw_input_data_wnd_proc(HWND hWnd, UINT msg,
+    WPARAM wParam, LPARAM lParam)
+{
+    UINT dwSize, ret2;
+    RAWINPUT *raw;
+    BOOL ret;
+    LRESULT ret3;
+    DWORD error;
+
+    legacy_mouse_message_recieved    |= msg >= WM_MOUSEFIRST && msg <= WM_MOUSELAST;
+    legacy_keyboard_message_recieved |= msg >= WM_KEYFIRST   && msg <= WM_KEYLAST;
+
+    switch (msg)
+    {
+    case WM_INPUT:
+        /* Now that we have a valid HRAWINPUT handle,
+           let's test the case, when &dwSize is NULL */
+        SetLastError(0xdeadbeef);
+        ret = pGetRawInputData((HRAWINPUT)lParam, RID_INPUT, NULL, NULL,
+            sizeof(RAWINPUTHEADER));
+        error = GetLastError();
+        ok(ret == (UINT)-1, "GetRawInputData returned wrong value: "
+            "expected (UINT)-1, got %u\n", ret);
+        ok(error == ERROR_NOACCESS, "GetRawInputData returned "
+            "wrong error code: %u\n", error);
+
+        /* Test retrieving of RAWINPUT data */
+        ret2 = pGetRawInputData((HRAWINPUT)lParam, RID_INPUT, NULL, &dwSize,
+            sizeof(RAWINPUTHEADER));
+        ok(ret2 == 0, "GetRawInputData failed to retrieve raw input data size\n");
+
+        if (!(raw = HeapAlloc(GetProcessHeap(), 0, dwSize)))
+            break;
+        ret2 = pGetRawInputData((HRAWINPUT)lParam, RID_INPUT, raw, &dwSize,
+            sizeof(RAWINPUTHEADER));
+        ok(ret2 == dwSize, "GetRawInputData failed to retrieve raw input data\n");
+        ok(raw->header.dwType == RIM_TYPEMOUSE || raw->header.dwType == RIM_TYPEKEYBOARD,
+            "Raw input data entry was not from mouse or keyboard, expected otherwise\n");
+
+        ret3 = pDefRawInputProc(&raw, 1, sizeof(RAWINPUTHEADER));
+        ok(ret3 == S_OK, "DefRawInputProc failed\n");
+
+        ret2 = pGetRawInputData((HRAWINPUT)lParam, RID_INPUT, raw, &dwSize,
+            sizeof(RAWINPUTHEADER));
+        ok(ret2 == dwSize, "GetRawInputData failed to reretrieve raw input data after "
+            "calling DefRawInputProc\n");
+
+        HeapFree(GetProcessHeap(), 0, raw);
+        wm_input_recieved = TRUE;
+        return ret3;
+    }
+    return DefWindowProcA(hWnd, msg, wParam, lParam);
+}
+
+#define ID_TIMER 1
+
+static void timer_proc(HWND hParent, UINT uMsg, UINT uEventID, DWORD dwTimer)
+{
+    PostQuitMessage(0);
+}
+
+static HWND test_get_raw_input_data_simulation_setup(HANDLE hInstance, const char *class_name,
+    RAWINPUTDEVICE *device, INPUT *input, UINT input_count)
+{
+    MSG msg;
+    BOOL ret;
+    UINT ret2, size, ret3, i;
+    RAWINPUT *raw, *raw2;
+
+    HWND hWnd = CreateWindowA(class_name, "GetRawInputDataTest", WS_OVERLAPPEDWINDOW,
+        10, 10, 200, 200, NULL, NULL, hInstance, NULL);
+    assert(hWnd);
+
+    ShowWindow(hWnd, SW_SHOW);
+    SetWindowPos(hWnd, HWND_TOPMOST, 10, 10, 200, 200, SWP_NOSIZE|SWP_NOMOVE);
+    SetForegroundWindow(hWnd);
+    UpdateWindow(hWnd);
+    SetFocus(hWnd);
+
+    /* Flush queued messages */
+    while (PeekMessageA(&msg, 0, 0, 0, PM_REMOVE))
+    {
+        TranslateMessage(&msg);
+        DispatchMessageA(&msg);
+    }
+
+    wm_input_recieved                = FALSE;
+    legacy_mouse_message_recieved    = FALSE;
+    legacy_keyboard_message_recieved = FALSE;
+
+    device->hwndTarget = hWnd;
+    ret = pRegisterRawInputDevices(device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to subscribe to "
+        "a raw input device: %u\n", GetLastError());
+
+    ok(!GetInputState(), "GetInputState returned that there are mouse or keyboard "
+        "messages queued, expected otherwise\n");
+    size = 0xdeadbeef;
+    ret2 = pGetRawInputBuffer(NULL, &size, sizeof(RAWINPUTHEADER));
+    ok(ret2 == 0, "GetRawInputBuffer returned wrong value: expected 0, got %u\n", ret2);
+    ok(size == 0, "GetRawInputBuffer returned incorrect minimum buffer size: "
+        "expected 0, got %u\n", size);
+
+    /* First send input to test raw input buffer */
+    pSendInput(input_count, input, sizeof(INPUT));
+
+    ok(GetQueueStatus(QS_RAWINPUT), "GetQueueStatus returned that the queue was "
+        "not marked as containing raw input messages, expected otherwise\n");
+    size = 0;
+    ret2 = pGetRawInputBuffer(NULL, &size, sizeof(RAWINPUTHEADER));
+    ok(ret2 == 0, "GetRawInputBuffer returned wrong value: expected 0, got %u\n", ret2);
+    ok(size > 0, "GetRawInputBuffer returned incorrect minimum buffer size: "
+        "expected x > 0, got %u\n", size);
+
+    /* Size variable is the size of a single entry of what GetRawInputBuffer will return,
+       therefore we will allocate enough space to accommodate 16 entries */
+    size *= 16;
+    raw = HeapAlloc(GetProcessHeap(), 0, size * sizeof(RAWINPUT));
+    ok(raw != NULL, "HeapAlloc failed to allocate memory for raw input buffer data\n");
+    if (raw)
+    {
+        ret3 = pGetRawInputBuffer(raw, &size, sizeof(RAWINPUTHEADER));
+        ok(ret3 > 0 && ret3 != (UINT)-1, "GetRawInputBuffer failed to read raw input buffer\n");
+        for (i = 0, raw2 = raw; ret3 != (UINT)-1 && i < ret3; i++)
+        {
+            ok(raw2->header.dwType == RIM_TYPEMOUSE || raw2->header.dwType == RIM_TYPEKEYBOARD,
+                "Raw input event was not from mouse or keyboard, expected otherwise\n");
+            ok(
+                (raw2->header.dwType == RIM_TYPEMOUSE &&
+                raw2->header.dwSize == sizeof(RAWINPUTHEADER) + sizeof(RAWMOUSE)) ||
+                (raw2->header.dwType == RIM_TYPEKEYBOARD &&
+                raw2->header.dwSize == sizeof(RAWINPUTHEADER) + sizeof(RAWKEYBOARD)),
+                "Raw input event size didn't match the one expected for mouse or keyboard\n");
+            raw2 = NEXTRAWINPUTBLOCK(raw2);
+        }
+        HeapFree(GetProcessHeap(), 0, raw);
+    }
+    ret2 = pGetRawInputBuffer(NULL, &size, sizeof(RAWINPUTHEADER));
+    ok(ret2 == 0, "GetRawInputBuffer returned wrong value: expected 0, got %u\n", ret2);
+    ok(size == 0, "GetRawInputBuffer returned incorrect minimum buffer size: "
+        "expected 0, got %u\n", size);
+
+    /* Proceed with testing other functionality */
+    pSendInput(input_count, input, sizeof(INPUT));
+
+    ok(GetQueueStatus(QS_RAWINPUT), "GetQueueStatus returned that the queue was "
+        "not marked as containing raw input messages, expected otherwise\n");
+    ret2 = pGetRawInputBuffer(NULL, &size, sizeof(RAWINPUTHEADER));
+    ok(ret2 == 0, "GetRawInputBuffer returned wrong value: expected 0, got %u\n", ret2);
+    ok(size > 0, "GetRawInputBuffer returned incorrect minimum buffer size: "
+        "expected x > 0, got %u\n", size);
+
+    /* Give half a second of running time for each test to be sure all messages are processed */
+    SetTimer(hWnd, ID_TIMER, 500, (TIMERPROC)timer_proc);
+
+    while (1 == 1)
+    {
+        ret = GetMessageA(&msg, NULL, 0, 0);
+        if (!ret || ret == (BOOL)-1)
+            break;
+        TranslateMessage(&msg);
+        DispatchMessageA(&msg);
+    }
+
+    ok(ret != -1, "Error getting window message: %u\n", GetLastError());
+    ok(wm_input_recieved, "WM_INPUT was not received\n");
+    ok(!GetQueueStatus(QS_RAWINPUT), "GetQueueStatus returned that the queue was "
+        "marked as containing raw input messages, expected otherwise\n");
+
+    return hWnd;
+}
+
+static void test_get_raw_input_data_simulation_teardown(HWND hWnd, RAWINPUTDEVICE *device)
+{
+    BOOL ret;
+    UINT ret2;
+    DWORD count;
+
+    KillTimer(hWnd, ID_TIMER);
+
+    device->dwFlags    = RIDEV_REMOVE | (device->usUsage == 0 ? RIDEV_PAGEONLY : 0);
+    device->hwndTarget = NULL;
+    ret = pRegisterRawInputDevices(device, 1, sizeof(RAWINPUTDEVICE));
+    ok(ret, "RegisterRawInputDevices failed to unsubscribe from "
+        "a raw input device: %u\n", GetLastError());
+
+    count = 0xdeadbeef;
+    ret2 = pGetRegisteredRawInputDevices(NULL, &count, sizeof(RAWINPUTDEVICE));
+    ok(ret2 == 0, "GetRegisteredRawInputDevices returned wrong value: "
+        "expected 0, got %u\n", ret2);
+    ok(count == 0, "GetRegisteredRawInputDevices returned incorrect registration count: "
+        "expected 0, got %u\n", count);
+
+    DestroyWindow(hWnd);
+}
+
+static void test_get_raw_input_data_simulation(void)
+{
+    HWND hWnd;
+    WNDCLASSA wclass;
+    HANDLE hInstance = GetModuleHandleA( NULL );
+    INPUT mouse_input[5], keyboard_input;
+    ATOM registration;
+    RAWINPUTDEVICE device;
+    unsigned int i;
+
+    if (!pRegisterRawInputDevices || !pGetRawInputData || !pDefRawInputProc ||
+        !pGetRawInputBuffer || !pSendInput)
+    {
+        win_skip("Functions required to perform raw input simulation are not available\n");
+        return;
+    }
+
+    wclass.lpszClassName = "GetRawInputDataTestClass";
+    wclass.style         = CS_HREDRAW | CS_VREDRAW;
+    wclass.lpfnWndProc   = get_raw_input_data_wnd_proc;
+    wclass.hInstance     = hInstance;
+    wclass.hIcon         = LoadIconA(0, IDI_APPLICATION);
+    wclass.hCursor       = LoadCursorA(NULL, IDC_ARROW);
+    wclass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
+    wclass.lpszMenuName  = NULL;
+    wclass.cbClsExtra    = 0;
+    wclass.cbWndExtra    = 0;
+    registration = RegisterClassA(&wclass);
+    assert(registration);
+
+    /* Setup fixtures */
+    device.usUsagePage = HID_USAGE_PAGE_GENERIC;
+
+    memset(&keyboard_input, 0, sizeof(keyboard_input));
+    keyboard_input.type   = INPUT_KEYBOARD;
+    keyboard_input.ki.wVk = VK_SPACE;
+
+    /* Be sure to move over the window, because the absolute window position on the screen
+       depends on how desktop widgets are placed */
+    memset(&mouse_input, 0, sizeof(mouse_input));
+    mouse_input[0].type           = INPUT_MOUSE;
+    mouse_input[0].mi.dx          = mouse_input[0].mi.dy = 15;
+    mouse_input[0].mi.dwFlags     = MOUSEEVENTF_MOVE | MOUSEEVENTF_ABSOLUTE;
+    mouse_input[1].type           = INPUT_MOUSE;
+    mouse_input[1].mi.mouseData   = 0x0078;
+    mouse_input[1].mi.dwFlags     = MOUSEEVENTF_WHEEL;
+    for (i = 2; i < sizeof(mouse_input) / sizeof(mouse_input[0]); i++)
+    {
+        mouse_input[i].type       = INPUT_MOUSE;
+        mouse_input[i].mi.dx      = mouse_input[i].mi.dy = 30;
+        mouse_input[i].mi.dwFlags = MOUSEEVENTF_MOVE;
+    }
+
+    /* Test WM_INPUT for mouse */
+    device.usUsage = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags = 0;
+
+    hWnd = test_get_raw_input_data_simulation_setup(hInstance, wclass.lpszClassName, &device,
+        mouse_input, 5);
+    ok(legacy_mouse_message_recieved,
+        "Didn't receive legacy mouse messages, while was expecting to\n");
+    test_get_raw_input_data_simulation_teardown(hWnd, &device);
+
+    /* Test WM_INPUT for keyboard */
+    device.usUsage = HID_USAGE_GENERIC_KEYBOARD;
+    device.dwFlags = 0;
+
+    hWnd = test_get_raw_input_data_simulation_setup(hInstance, wclass.lpszClassName, &device,
+        &keyboard_input, 1);
+    ok(legacy_keyboard_message_recieved,
+        "Didn't receive keyboard messages, while was expecting to\n");
+    test_get_raw_input_data_simulation_teardown(hWnd, &device);
+
+    /* Test RIDEV_PAGEONLY using mouse */
+    device.usUsage = 0;
+    device.dwFlags = RIDEV_PAGEONLY;
+
+    hWnd = test_get_raw_input_data_simulation_setup(hInstance, wclass.lpszClassName, &device,
+        mouse_input, 5);
+    ok(legacy_mouse_message_recieved,
+        "Didn't receive legacy mouse messages, while was expecting to\n");
+    test_get_raw_input_data_simulation_teardown(hWnd, &device);
+
+    /* Test RIDEV_PAGEONLY using keyboard */
+    device.usUsage = 0;
+    device.dwFlags = RIDEV_PAGEONLY;
+
+    hWnd = test_get_raw_input_data_simulation_setup(hInstance, wclass.lpszClassName, &device,
+        &keyboard_input, 1);
+    ok(legacy_keyboard_message_recieved,
+        "Didn't receive legacy keyboard messages, while was expecting to\n");
+    test_get_raw_input_data_simulation_teardown(hWnd, &device);
+
+    /* Test RIDEV_NOLEGACY for mouse */
+    device.usUsage = HID_USAGE_GENERIC_MOUSE;
+    device.dwFlags = RIDEV_NOLEGACY;
+
+    hWnd = test_get_raw_input_data_simulation_setup(hInstance, wclass.lpszClassName, &device,
+        mouse_input, 5);
+    ok(!legacy_mouse_message_recieved,
+        "Did receive legacy mouse messages, while was expecting not to\n");
+    test_get_raw_input_data_simulation_teardown(hWnd, &device);
+
+    /* Test RIDEV_NOLEGACY for keyboard */
+    device.usUsage = HID_USAGE_GENERIC_KEYBOARD;
+    device.dwFlags = RIDEV_NOLEGACY;
+
+    hWnd = test_get_raw_input_data_simulation_setup(hInstance, wclass.lpszClassName, &device,
+        &keyboard_input, 1);
+    ok(!legacy_keyboard_message_recieved,
+        "Did receive legacy mouse messages, while was expecting not to\n");
+    test_get_raw_input_data_simulation_teardown(hWnd, &device);
+}
+
 START_TEST(input)
 {
     init_function_pointers();
